;===================================================================================================
; TomoeLib / gGCu
; Version 0.07, June 19, 2007
; Copyright (C) DgG
;===================================================================================================
#ifndef __TomoeLib__
#define __TomoeLib__

;===================================================================================================
; ŏlEől֐
;===================================================================================================
#module
#defcfunc min int a, int b
  if a < b { return a }else{ return b }
#defcfunc max int a, int b
  if a > b { return a }else{ return b }
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc dmin double a, double b
  if a < b { return a }else{ return b }
#defcfunc dmax double a, double b
  if a > b { return a }else{ return b }
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc swap var a, var b ;y߁z
  t = a : a = b : b = t : return
#global

;===================================================================================================
; lr֐
;===================================================================================================
#module
#defcfunc intcmp int a, int b
  return a-b
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc doublecmp double a, double b
  r = a-b
  if r < 0.0 : return -1
  if r > 0.0 : return  1
  return 0
#global

;===================================================================================================
; r֐
;===================================================================================================
#module
#defcfunc strcmp str s1, str s2
  t1 = s1 : n1 = strlen(t1)
  t2 = s2 : n2 = strlen(t2) : n = min(n1,n2)

  r = 0 : repeat n+1
    c1 = peek(t1,cnt)
    c2 = peek(t2,cnt)
    r  = c1 - c2 : if r != 0 : break
  loop

  return r
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc strncmp str s1, str s2, int n
  t1 = s1 : t1 = strmid(t1,0,n)
  t2 = s2 : t2 = strmid(t2,0,n)
  return strcmp(t1,t2)
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc strmatch str s, str pat, int index
  s2 = pat : n  = strlen(s2)
  s1 = s   : s1 = strmid(s1,index,n)
  if strncmp(s1,s2,n) == 0 { return 1 }else{ return 0 }
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc strlmatch str s, str pat
  return strmatch(s,pat,0)
#defcfunc strrmatch str s, str pat
  return strmatch(s,pat,-1)
#global

;===================================================================================================
; R[h֐
;===================================================================================================
#define global CHARCODE_ASCII    'A'
#define global CHARCODE_HANKAKU  'H'
#define global CHARCODE_ZENKAKU1 '1'
#define global CHARCODE_ZENKAKU2 '2'

;---------------------------------------------------------------------------------------------------
#module
#defcfunc StrIndexOK str src, int index
  n = strlen(src)
  if (index < 0) or (n-1 < index) { return 0 }else{ return 1 }
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc SjisCheckStr var check, str src ;y߁z
  check = src : n = strlen(check) : zen = 0
  repeat n
    c = peek(check,cnt)
    if zen == 0 {
      if (0x00 <= c) and (c <= 0x7F) { poke check,cnt,CHARCODE_ASCII    : continue }
      if (0xA0 <= c) and (c <= 0xDF) { poke check,cnt,CHARCODE_HANKAKU  : continue }
                                       poke check,cnt,CHARCODE_ZENKAKU1 : zen = 1
    }else{                             poke check,cnt,CHARCODE_ZENKAKU2 : zen = 0  }
  loop
  return
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc IsCHARCODE str src, int index, int code
  if StrIndexOK(src,index) {
    SjisCheckStr check,src
    c = peek(check,index) : if c == code : return 1
  }
  return 0
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc IsASCII    str src, int index
  return  IsCHARCODE(src,index,CHARCODE_ASCII)
#defcfunc IsHANKAKU  str src, int index
  return  IsCHARCODE(src,index,CHARCODE_HANKAKU)
#defcfunc IsZENKAKU1 str src, int index
  return  IsCHARCODE(src,index,CHARCODE_ZENKAKU1)
#defcfunc IsZENKAKU2 str src, int index
  return  IsCHARCODE(src,index,CHARCODE_ZENKAKU2)
#defcfunc IsZENKAKU  str src, int index
  return  IsCHARCODE(src,index,CHARCODE_ZENKAKU1) or IsCHARCODE(src,index,CHARCODE_ZENKAKU2)
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc TrStr var s, int from, int to ;y߁z
  SjisCheckStr check, s : n = strlen(s)
  repeat n
    if peek(s,cnt) == from {
      c = peek(check,cnt)
      if ( c == CHARCODE_ASCII ) or ( c == CHARCODE_HANKAKU ) : poke s,cnt,to
    }
  loop
  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc toupper var s ;y߁z
  SjisCheckStr check, s : n = strlen(s)
  repeat n
    if peek(check,cnt) == CHARCODE_ASCII {
      c = peek(s,cnt) : p = c - 'a'
      if ('a'<=c) and (c<='z') : poke s,cnt,'A'+p
    }
  loop
  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc tolower var s ;y߁z
  SjisCheckStr check, s : n = strlen(s)
  repeat n
    if peek(check,cnt) == CHARCODE_ASCII {
      c = peek(s,cnt) : p = c - 'A'
      if ('A'<=c) and (c<='Z') : poke s,cnt,'a'+p
    }
  loop
  return
#global

;===================================================================================================
; g֐
;===================================================================================================
#module
#defcfunc rtrimc str s, int c
  t = s : n = strlen(t)
  repeat n
    d = peek(t,n-1-cnt)
    if d == c { poke t,n-1-cnt,0 }else{ break }
  loop
  return t
#defcfunc rtrim str s
  return rtrimc(s,' ')
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc ltrimc str s, int c
  t = s : n = strlen(t) : i=0
  repeat n
    d = peek(t,cnt)
    if d == c { i++ }else{ break }
  loop
  return strmid(t,i,n)
#defcfunc ltrim str s
  return ltrimc(s,' ')
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc trimc str s, int c
  return ltrimc( rtrimc(s,c), c )
#defcfunc trim  str s
  return ltrim(  rtrim(s) )
#global

;===================================================================================================
; m[gpbh⏕֐
;===================================================================================================
#module
#defcfunc notegets var note, int index
  notesel note
  noteget s,index
  return  s
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc notegeti var note, int index
  return  int(    notegets(note,index) )
#defcfunc notegetd var note, int index
  return  double( notegets(note,index) )
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc NoteDelNullStr var note ;y߁z
  notesel note : n = notemax : i=0
  repeat n
    noteget s,i
    if s == "" { notedel i }else{ i++ }
  loop
  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc NoteDelComment var note, str c ;y߁zsRg܂ŉȂꍇ̂ݍ폜
  notesel note : n = notemax : i=0
  repeat n
    noteget s,i
    if strlmatch(s,c) { notedel i }else{ i++ }
  loop
  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc NoteSplit str pat, str src, var note ;y߁zNoteSplit ":","12:34:56",note
  n_pat = strlen(pat) : if n_pat == 0 : return
  s = src : n = strlen(s) : index = 0
  note = "" : notesel note

  repeat
    i = instr(s,index,pat)
    if i == -1 { noteadd strmid(s,index,n) : break }
    noteadd strmid(s,index,i)
    index += i + n_pat : if index > n-1 : break
  loop

  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc NoteJoin str pat, var note, var dst ;y߁zNoteJoin ":",note,dst
  dst = "" : notesel note : n = notemax

  repeat n
    if cnt != 0   : dst += pat
    noteget s,cnt : dst += s
  loop

  return
#global

;===================================================================================================
; pX֘A֐
;===================================================================================================
#module
#defcfunc IsFullPath str path
  s  = path
  c0 = strmid(s,0,1) : if (c0=="/") or (c0=="\\") : return 1
  c1 = strmid(s,1,1) : if (c1==":")               : return 1
  return 0
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc IsHttp str path
  s  = path
  if getpath( strmid(s,0,5),16 ) == "http:" : return 1
  return 0
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc IsDir str path
  dirlist note,path,5
  if stat == 1 { return 1 }else{ return 0 }
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc IsFile str path
  exist path
  if strsize >= 0 { return 1 }else{ return 0 }
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc CheckPathYen str path
  s  = path : index = strlen(s)-1
  if StrIndexOK(s,index) {
    c = strmid(s,index,1)
    if (c=="/") or (c=="\\") { if IsASCII(s,index) { return 1 } }
  }
  return 0
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc AddPathYen str path
  s  = path
  if CheckPathYen(s) == 0 : s += "\\"
  return s
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc DelPathYen str path
  s  = path : index = strlen(s)-1
  if StrIndexOK(s,index) and CheckPathYen(s) : poke s,index,0
  return s
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc DirUnixType str path
  s  = path : TrStr s,'\\','/' : return s
#defcfunc DirWinType  str path
  s  = path : TrStr s,'/','\\' : return s
#global

;---------------------------------------------------------------------------------------------------
#module
#defcfunc GetRelativePath str path, str dir
  s1 = DirWinType(path) : tolower s1 : s1 = DelPathYen(s1)
  s2 = DirWinType(dir)  : tolower s2 : s2 = DelPathYen(s2)
  NoteSplit "\\",s1,note1 : notesel note1 : n1 = notemax
  NoteSplit "\\",s2,note2 : notesel note2 : n2 = notemax : n = min(n1,n2)

  i=0 : s=""
  repeat n
    if notegets(note1,cnt) != notegets(note2,cnt) : break
    i++
  loop

  r2 = n2 - i : if r2 > 0 { repeat r2 : s += "..\\" : loop }
  r1 = n1 - i : if r1 > 0 {
    repeat r1,i
      s += notegets(note1,cnt)
      if cnt != n1-1 : s += "\\"
    loop
  }

  return s
#global

;===================================================================================================
; t@CXg擾
;===================================================================================================
#module
#deffunc GetFileList str dir, var note ;y߁z
  sdir = DelPathYen(dir) : if IsDir(sdir) == 0 : return
  cdir = dir_cur : chdir sdir

  dirlist list,"*.*",1
  notesel list : n = notemax
  repeat n
    fn = sdir +"\\"+ notegets(list,cnt)
    notesel note : noteadd fn
  loop

  chdir cdir
  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc GetFileListR str dir, var note, local sdir, local cdir, local list, local n ;y߁z
  GetFileList dir,note : await 0

  sdir = DelPathYen(dir) : if IsDir(sdir) == 0 : return
  cdir = dir_cur : chdir sdir

  dirlist list,"*.*",5
  notesel list : n = notemax
  repeat n
    fn = sdir +"\\"+ notegets(list,cnt)
    GetFileListR fn,note
  loop

  chdir cdir
  return
#global

;===================================================================================================
; csv֐
; J}E_uNH[e[V܂ޏꍇA_uNH[e[Vň͂ށB
; _uNH[e[V "" ŃGXP[vB
; i̊֐͉s܂ރf[^͈Ȃj
;===================================================================================================
#module
#defcfunc CsvEscape str s
  src = s : n = strlen(src)

  comma = 0
  quot  = 0
  repeat n
    c = peek(src,cnt)
    if c == ',' : comma++
    if c == '"' : quot++
  loop
  if ( comma == 0 ) and ( quot == 0 ) : return src

  sdim dst, n+2+quot : i=1
  poke dst, 0         ,'"'
  poke dst, n+2+quot-1,'"'
  repeat n
    c = peek(src,cnt) : poke dst,i,c:i++
    if c == '"'       : poke dst,i,c:i++
  loop

  return dst
#global

;===================================================================================================
; csv  m[gpbhϊ
;===================================================================================================
#module
#deffunc csv2note str csv, var note ;y߁z
  src = csv : n = strlen(src)+1 : sdim tmp,n : memset tmp,0,n:i=0
  note = "" : notesel note

  in_quot = 0
  in_esc  = 0
  repeat n-1
    c = peek(src,cnt)
    if in_esc {
      in_esc  = 0 : if c == '"' { poke tmp,i,c:i++ : continue }
      in_quot = 0
    }
    if in_quot {
      if c == '"' { in_esc = 1 : continue }
      poke tmp,i,c:i++ : continue
    }
    if c == '"' { in_quot = 1 : continue }
    if c == ',' { noteadd tmp : memset tmp,0,n:i=0 : continue }
    poke tmp,i,c:i++ : continue
  loop
  noteadd tmp

  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc note2csv var note, var csv ;y߁z
  csv = "" : notesel note : n = notemax
  repeat n
    if cnt != 0 : csv += ","
    csv += CsvEscape( notegets(note,cnt) )
  loop
  return
#global

;===================================================================================================
; csv  zϊ
;===================================================================================================
#module
#deffunc csv2array str csv, array sa ;y߁z
  src = csv : n = strlen(src)+1 : sdim tmp,n : memset tmp,0,n:i=0
  sdim sa,256,1 : index = 0

  in_quot = 0
  in_esc  = 0
  repeat n-1
    c = peek(src,cnt)
    if in_esc {
      in_esc  = 0 : if c == '"' { poke tmp,i,c:i++ : continue }
      in_quot = 0
    }
    if in_quot {
      if c == '"' { in_esc = 1 : continue }
      poke tmp,i,c:i++ : continue
    }
    if c == '"' { in_quot = 1 : continue }
    if c == ',' { sa(index) = str(tmp) : index++ : memset tmp,0,n:i=0 : continue }
    poke tmp,i,c:i++ : continue
  loop
  sa(index) = str(tmp)

  return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc array2csv array sa, var csv ;y߁z
  csv = "" : n = length(sa)
  repeat n
    if cnt != 0 : csv += ","
    csv += CsvEscape( str(sa(cnt)) )
  loop
  return
#global

;===================================================================================================
; Ȉcsv\[g(x)
;===================================================================================================
#define global ORDER_BY_INT_ASC     1 ; 
#define global ORDER_BY_INT_DESC    2 ; ~
#define global ORDER_BY_DOUBLE_ASC  3 ; 
#define global ORDER_BY_DOUBLE_DESC 4 ; ~
#define global ORDER_BY_STR_ASC     5 ; 񏸏
#define global ORDER_BY_STR_DESC    6 ; ~

;---------------------------------------------------------------------------------------------------
#module ;y߁z
#deffunc SortCsvNote var note, int idx1,int ob1, int idx2,int ob2, int idx3,int ob3, int idx4,int ob4
  notesel note : n = notemax : if n==0 : return
  idx = idx1, idx2, idx3, idx4
  ob  =  ob1,  ob2,  ob3,  ob4
  obt =    0,    0,    0,    0
  cmp =    0,    0,    0,    0
  n_ob = 0 : repeat 4
    if ob(3-cnt) { n_ob = 4-cnt : break }
  loop

  sdim sa,256,n
  repeat n
    notesel note : noteget csv,cnt
    csv2note csv,sa(cnt)
  loop

  repeat : sort = 0
    repeat n-1 : i = cnt
      repeat n_ob : x = cnt
        switch ob(x)
        case ORDER_BY_INT_ASC     : cmp(x) =    intcmp( notegeti(sa(i),idx(x)),notegeti(sa(i+1),idx(x)) ) : swbreak
        case ORDER_BY_INT_DESC    : cmp(x) =    intcmp( notegeti(sa(i+1),idx(x)),notegeti(sa(i),idx(x)) ) : swbreak
        case ORDER_BY_DOUBLE_ASC  : cmp(x) = doublecmp( notegetd(sa(i),idx(x)),notegetd(sa(i+1),idx(x)) ) : swbreak
        case ORDER_BY_DOUBLE_DESC : cmp(x) = doublecmp( notegetd(sa(i+1),idx(x)),notegetd(sa(i),idx(x)) ) : swbreak
        case ORDER_BY_STR_ASC     : cmp(x) =    strcmp( notegets(sa(i),idx(x)),notegets(sa(i+1),idx(x)) ) : swbreak
        case ORDER_BY_STR_DESC    : cmp(x) =    strcmp( notegets(sa(i+1),idx(x)),notegets(sa(i),idx(x)) ) : swbreak
        default: ob(x) = 0 : swbreak
        swend
        if cmp(x) < 0 { obt(x) = 0 }else{ obt(x) = 1 }
      loop
      if obt(0) { if cmp(0) { swap sa(i),sa(i+1) : sort = 1 : continue }
      if obt(1) { if cmp(1) { swap sa(i),sa(i+1) : sort = 1 : continue }
      if obt(2) { if cmp(2) { swap sa(i),sa(i+1) : sort = 1 : continue }
      if obt(3) { if cmp(3) { swap sa(i),sa(i+1) : sort = 1 : continue } } } } }
      await 0
    loop
    if sort == 0 : break
  loop

  note = ""
  repeat n
    note2csv sa(cnt),csv
    notesel note : noteadd csv
  loop
  sdim sa,256,0

  return
#global

;---------------------------------------------------------------------------------------------------
#module ;y߁z
#deffunc SortCsvFile str from, str to, int idx1,int ob1, int idx2,int ob2, int idx3,int ob3, int idx4,int ob4
  exist from : if strsize < 0 : return
  note = "" : notesel note : noteload from
  SortCsvNote note, idx1,ob1, idx2,ob2, idx3,ob3, idx4,ob4
  notesel note : notesave to
return
#global

;===================================================================================================
; m3ut@Cϊ
;===================================================================================================
#module
#defcfunc NonNullLength array sa
  n = length(sa) : i = n-1
  repeat n
    if sa(i) != "" { break }else{ i-- }
  loop
return i+1
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc note2arrayaddM3U var note, array f_path, array f_title, array f_length ;y߁z
  NoteDelNullStr note : notesel note : n = notemax
  index = NonNullLength( f_path )

  if strlmatch( notegets(note,0), "#EXTM3U" ) {
    ExtendedTitle  = ""
    ExtendedLength = 0
    repeat n-1,1
      s = notegets(note,cnt)
      if strlmatch( s, "#EXTINF:" ) {
        slen = strlen(s) : s = strmid(s,8,slen) : i = instr(s,0,",")
        if i >= 0 {
          ExtendedTitle  = strmid(s,i+1,slen)
          ExtendedLength = int( strmid(s,0,i) )
        }else{
          ExtendedTitle  = ""
          ExtendedLength = 0
        }
      }else{
        f_path(index)   = s
        f_title(index)  = ExtendedTitle
        f_length(index) = ExtendedLength : index++
      }
    loop
  }else{
    repeat n
      s = notegets(note,cnt)
      f_path(index)   = s
      f_title(index)  = getpath(s,8)
      f_length(index) = 0 : index++
    loop
  }

return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc note2arrayM3U var note, array f_path, array f_title, array f_length ;y߁z
  NoteDelNullStr note : notesel note : n = max( notemax,1 )
  sdim f_path ,32,n
  sdim f_title,32,n
  dim  f_length  ,n
  note2arrayaddM3U note, f_path, f_title, f_length
return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc array2noteaddEXTM3U array f_path, array f_title, array f_length, var note ;y߁z
  n = length( f_path ) : notesel note
  repeat n
    if f_path(cnt) == "" : continue
    noteadd "#EXTINF:"+ f_length(cnt) +","+ f_title(cnt)
    noteadd f_path(cnt) +"\n"
  loop
return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc array2noteEXTM3U array f_path, array f_title, array f_length, var note ;y߁z
  note = "" : notesel note : noteadd "#EXTM3U\n"
  array2noteaddEXTM3U f_path, f_title, f_length, note
return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc array2noteaddM3U array f_path, var note ;y߁z
  n = length( f_path ) : notesel note
  repeat n
    if f_path(cnt) == "" : continue
    noteadd f_path(cnt)
  loop
return
#global

;---------------------------------------------------------------------------------------------------
#module
#deffunc array2noteM3U array f_path, var note ;y߁z
  note = "" : array2noteaddM3U f_path, note
return
#global

;===================================================================================================
#endif ; #ifndef __TomoeLib__
;===================================================================================================
